import java.util.*;


public class DGYahtzee
{
	public static void main(String[] args)
	{
//		test();
		playGame();
	}

	public static void playGame()
	{
		// Declare variables.
		Scanner s = new Scanner( System.in );			
		int numRolls;

		// Create game.			
		Dice dice = new Dice();
		Referee ref = new Referee();
		
		// Make first roll
		dice.roll();
		System.out.println( "\nFirst Roll    : " + Arrays.toString( dice.getStillRollingFaces() ) );		
		
		// Allow user to keep some of the rolls.
		addToKeepers( dice );

		// See if game is over (user kept all rolls)
		if( dice.getNumKept() == 5 )
		{
			scoreRound( ref, dice );
			return;
		}

		// Make second roll.			
		dice.roll();
		System.out.println( "\nSecond Roll   : " + Arrays.toString( dice.getStillRollingFaces() ) );		

		// See if user wants to remove any keepers.
		removeFromKeepers( dice );

 		// See if the user wants to keep some of the rolls.
 		addToKeepers( dice );

		// See if game is over (have five keepers)
		if( dice.getNumKept() == 5 )
		{
			scoreRound( ref, dice );
			return;
		}

		// Make third roll.			
		dice.roll();
		System.out.println( "\nThird Roll    : " + Arrays.toString( dice.getStillRollingFaces() ) );		

		// Automatically keep the rolls (i.e. no more rolls)
		dice.keepAll();
// 		for( int f : roll )
// 			keepers.addFace( f );
		
		// Display results.
		scoreRound( ref, dice );
	
	}
	
	public static void test()
	{
		int[] roll;
		Referee ref = new Referee();

		Dice dice = new Dice();
		dice.roll();
		dice.keepAll();
		
		
		
		// Set Full House		
		roll = new int[]{3,3,2,3,2};
			
		ref.setFullHouse( dice );
		System.out.println( "Try Full House    : " + dice );

		// Check for 4-of-a-Kind
		ref.set4ofaKind(dice);
		System.out.println( "Try 4-of-a-kind   : " + dice );

		// Check for 3-of-a-Kind
		ref.set3ofaKind(dice);			
		System.out.println( "Try 3-of-a-kind   : " + dice );
		
		// Set Small Straight		
		ref.setSmallStraight(dice);
		System.out.println( "Try Small Straight: " + dice );

		// Set Large Straight		
		ref.setLargeStraight(dice);
		System.out.println( "Try Large Straight: " + dice );

		// Set Yahtzee		
		ref.setYahtzee(dice);
		System.out.println( "Try Yahtzee       : " + dice );
		
		// Check for Chance		
		ref.setChance(dice);
		System.out.println( "Try Chance        : " + dice );

		String s = ref.getBestType( dice );
		ref.setScore( s, dice );
		System.out.println( "Best              : " + dice );

	
	}
	
	public static void scoreRound( Referee ref, Dice dice )
	{
		if( dice.getNumKept() == 5 )
		{
			System.out.println( "Kept          : " + Arrays.toString( dice.getKeptFaces() ) );
			String bestType = ref.getBestType( dice );
			ref.setScore( bestType, dice );
			System.out.println( "Evaluation    : " + dice.getType() + ", Score=" + dice.getScore() );
		}
	
	}		
	public static void addToKeepers( Dice dice )
	{
		Scanner s = new Scanner( System.in );			
		int face;
		
		do
		{
			System.out.println( "Kept          : " + Arrays.toString( dice.getKeptFaces() ) );
			System.out.println( "Still Rolling : " + Arrays.toString( dice.getStillRollingFaces() ) );
 			System.out.print( "Which face do you want to keep(-1 to stop adding)? " );
			face = s.nextInt();
			if( face != -1 )
			{
				dice.keep( face );
			}
				
		} while( (face != -1) && (dice.getNumKept()<5) );
	}
	
	public static void removeFromKeepers( Dice dice )
	{
		Scanner s = new Scanner( System.in );			
		int face;

		do
		{
			System.out.println( "Kept          : " + Arrays.toString( dice.getKeptFaces() ) );
			System.out.println( "Still Rolling : " + Arrays.toString( dice.getStillRollingFaces() ) );
 			System.out.print( "Which face do you want to remove from the keepers(-1 to stop removing)? " );
			face = s.nextInt();
			if( face != -1 )
			{
				dice.putBack( face );
			}
				
		} while( (face != -1) && (dice.getNumKept()<5) );
	}	
} 
