public class Referee
{
		public void setFullHouse( Dice dice )
		{
			int score = 0;
			if( YahtzeeRules.isFullHouse( dice ) )
			{
				score = 25;
			}
			
			dice.setScore( "FULL HOUSE", score );
		}

		public void set4ofaKind( Dice dice )
		{
			int score = 0;
			if( YahtzeeRules.is4ofaKind( dice ) )
			{
				score = dice.getFacesTotal();
			}
			
			dice.setScore( "4-OF-A-KIND", score );
		}

		public void set3ofaKind( Dice dice )
		{
			int score = 0;
			if( YahtzeeRules.is3ofaKind( dice ) )
			{
				score = dice.getFacesTotal();
			}
			
			dice.setScore( "3-OF-A-KIND", score );
		}

		public void setSmallStraight( Dice dice )
		{
			int score = 0;
			if( YahtzeeRules.isSmallStraight( dice ) )
			{
				score = 30;
			}
			
			dice.setScore( "SMALL STRAIGHT", score );
		}

		public void setLargeStraight( Dice dice )
		{
			int score = 0;
			if( YahtzeeRules.isLargeStraight( dice ) )
			{
				score = 40;
			}
			
			dice.setScore( "LARGE STRAIGHT", score );

		}


		public void setYahtzee( Dice dice )
		{
			int score = 0;
			if( YahtzeeRules.isYahtzee( dice ) )
			{
				score = 50;
			}
			
			dice.setScore( "YAHTZEE", score );

		}

		public void setChance( Dice dice )
		{
			int score = 0;
			if( YahtzeeRules.isChance( dice ) )
			{
				score = dice.getFacesTotal();
			}
			
			dice.setScore( "CHANCE", score );

		}

		public String getBestType( Dice dice )
		{
			if      ( YahtzeeRules.isYahtzee( dice ) )       return "YAHTZEE";
			else if ( YahtzeeRules.isLargeStraight( dice ) ) return "LARGE STRAIGHT";
			else if ( YahtzeeRules.isSmallStraight( dice ) ) return "SMALL STRAIGHT";
			else if ( YahtzeeRules.isFullHouse( dice ) )
			{
				if( dice.getFacesTotal() > 25 )               return "3-OF-A-KIND";
				else                                             return "FULL HOUSE";
			}
			else if ( YahtzeeRules.is4ofaKind( dice ) )      return "4-OF-A-KIND";
			else if ( YahtzeeRules.is3ofaKind( dice ) )      return "3-OF-A-KIND";
			else														       return "CHANCE";
		}


		public void setScore( String type, Dice dice )
		{
			if      ( type.equals("YAHTZEE") )        setYahtzee( dice );
			else if ( type.equals("LARGE STRAIGHT") ) setLargeStraight( dice );
			else if ( type.equals("SMALL STRAIGHT") ) setSmallStraight( dice );
			else if ( type.equals("FULL HOUSE") )     setFullHouse( dice );
			else if ( type.equals("4-OF-A-KIND") )    set4ofaKind( dice );
			else if ( type.equals("3-OF-A-KIND") )    set3ofaKind( dice );
			else if ( type.equals("CHANCE") )         setChance( dice );
		}
// 	public String evaluate( Dice dice )
// 	{
// 		int[] counts = dice.counts();
// 		
// 		if( sumValues( counts ) != 5 ) return "Incomplete";
// 		
// 		int numVals = numValues( counts );
// 		
// 		switch( numVals )
// 		{
// 			case 1 :
// 				return "Yahtzee";
// 			case 2 :
// 				if( isFullHouse( counts ) ) return "Full House";
//  				else if( is4ofaKind( counts ) ) return "4 of a Kind";
// 				break;
// 			case 3 :
// 				if( is3ofaKind( counts ) ) return "3 of a Kind";
// 				break;
// 			case 4 : 
// 				if( is4CountSmallStraight( counts ) ) return "Small Straight";
// 				break;
// 			case 5 : 
// 				if( is5CountSmallStraight( counts ) ) return "Small Straight";
// 				else if( isLargeStraight( counts ) ) return "Large Straight";
// 				break;
// 		}
// 		return "Chance";
// 	}
// 	
// 	private boolean isFullHouse( int[] counts )
// 	{
// 		boolean threes = false, twos = false;
// 		
// 		for( int val : counts )
// 		{
// 			if( val == 3 ) threes = true;
// 			else if( val == 2 ) twos = true;
// 		}
// 		
// 		return twos && threes;
// 	}
// 	
// 	private boolean is4ofaKind( int[] counts )
// 	{
// 		boolean fours = false, one = false;
// 		
// 		for( int val : counts )
// 		{
// 			if( val == 4 ) fours = true;
// 			else if( val == 1 ) one = true;
// 		}
// 		
// 		return one && fours;
// 	}
// 
// 	private boolean is3ofaKind( int[] counts )
// 	{
// 		for( int val : counts )
// 			if( val == 3 ) return true;
// 		
// 		return false;
// 	}
// 
// 	private boolean is4CountSmallStraight( int[] counts )
// 	{
// 		boolean fourInaRow = true;
// 				
// 		for( int i=0; i<4; i++ )
// 			fourInaRow = fourInaRow && counts[i]>0;
// 			
// 		if( fourInaRow ) return true;
// 		
// 		fourInaRow = true;
// 		for( int i=1; i<5; i++ )
// 			fourInaRow = fourInaRow && counts[i]>0;
// 
// 		if( fourInaRow ) return true;
// 
// 		fourInaRow = true;
// 		for( int i=2; i<6; i++ )
// 			fourInaRow = fourInaRow && counts[i]>0;
// 
// 		if( fourInaRow ) return true;
// 		else return false;
// 	}
// 
// 	private boolean is5CountSmallStraight( int[] counts )
// 	{
// 		if( counts[1] == 0 || counts[4] == 0 ) 
// 			return true;
// 		else
// 			return false;
// 	}
// 
// 	private boolean isLargeStraight( int[] counts )
// 	{
// 		if( counts[0] == 0 || counts[5] == 0 ) 
// 			return true;
// 		else
// 			return false;
// 	}
// 	
// 	private int numValues( int[] counts )
// 	{
// 		int sum = 0;
// 		
// 		for( int val : counts )
// 			if( val > 0 ) sum++;
// 		
// 		return sum;
// 	}
// 
// 	private int sumValues( int[] counts )
// 	{
// 		int sum = 0;
// 		
// 		for( int val : counts )
// 			sum+=val;
// 		
// 		return sum;
// 	}
	
}
